/*
 *  Gnubile - Gnutella software for Unix
 *  Copyright (C) 2000  Spencer Kimball and Gene Kan
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/time.h>

#include "guid.h"

static guid s_guid;

void seedguid (void) {
        int i;
        struct timeval tv;

        gettimeofday(&tv, NULL);

	srand48(tv.tv_sec);

        for (i = 0; i < 4; i++)
                s_guid.u.private_ints[i] = lrand48();
}

guid getguid (void) {
        s_guid.u.private_ints[lrand48() % 4] = lrand48();

	/*printguid(s_guid);*/

	return s_guid;
}

void printguid (guid _guid) {
  printf("%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x\n",
		   _guid.u.private_bytes[0], _guid.u.private_bytes[1], _guid.u.private_bytes[2],
		   _guid.u.private_bytes[3], _guid.u.private_bytes[4], _guid.u.private_bytes[5],
		   _guid.u.private_bytes[6], _guid.u.private_bytes[7], _guid.u.private_bytes[8],
		   _guid.u.private_bytes[9], _guid.u.private_bytes[10], _guid.u.private_bytes[11],
		   _guid.u.private_bytes[12], _guid.u.private_bytes[13], _guid.u.private_bytes[14],
		   _guid.u.private_bytes[15]);
}
