/*-*-linux-c-*-*/

/*
 *  gnewtellium - Newtella for Unix
 *  Copyright (C) 2001 Elias Athanasopoulos
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef NEWTELLA_H
#define NEWTELLA_H

#include <gtk/gtk.h>

#include "guid.h"
#include "global.h"
#include "connection.h"
#include "memory.h"

/*
typedef enum {
       RESOLVE_NONE, RESOLVE_ADDRESSTONAME, RESOLVE_NAMETOADDRESS
} resolve_types;
*/

struct host_info {
	guint32 ip;
	guint16 port;
        time_t time;
	guint32 file_count, files_total_size, hops;
	char *host_name;
};

typedef struct {
	guint16 len;
	char buf[MAX_PACKET_LENGTH];
	guint32 _time;
} packet;

struct file_found {
	guid _guid;
	char *file_name;
	guint32 index;
	guint32 size;
	guint16 port;
        guint32 ip;
        guint32 speed;
	guint32 received;
};

struct routing_info {
	guint8 f;
        guint32 time;
        struct newtella_connection *con;
        guid _guid;
        /* HASH hash */ 
};
	
int newtella_sched(void);

int newtella_init_server(guint16 port);
int newtella_kill_server(void);
int newtella_welcome_client(gpointer gdata, gint s, GdkInputCondition cond);

int newtella_connect(guint32 ip, guint16 port);

int on_gnutellanet_read(gpointer gdata, gint s, GdkInputCondition cond);
int on_gnutellanet_write(gpointer gdata, gint s, GdkInputCondition cond);

int host_remove(guint32 ip, guint16 port);
int host_save_cache_to_file(void);
int host_load_cache_from_file(void);

gchar *ip2str(guint32 ip);
guint32 str2ip(gchar *str);

#endif










